package lc.astro.scheduler;

import lc.astro.catalog.CatalogObject;

/**
 * This class represents a mission objective in the astronomy planning ecosystem. A mission consists of an
 * observational goal. In the currently limited implementation, all objectives are said to be basic 80mm visual
 * observations in the narrowband ranges of Ha, OIII, SII.
 *
 * @author Alex Leigh
 */
public class Objective {
    private final CatalogObject object;

    public Objective(CatalogObject object) {
        this.object = object;
    }

    public CatalogObject getObject() {
        return object;
    }

}