package lc.cloudbox.cisco;

import lc.mecha.cred.Credential;

/**
 * A simple class for storing the login information required to generate {@link CiscoSession} objects.
 *
 * @author Alex Leigh
 */
public class CiscoController {
    private final String hostname;
    private final Credential loginCred;
    private final String enablePw;

    public CiscoController(String hostname, Credential loginCred, String enablePw) {
        this.hostname = hostname;
        this.loginCred = loginCred;
        this.enablePw = enablePw;
    }

    public CiscoSession getSession() throws Exception {
        return new CiscoSession(hostname, loginCred, enablePw);
    }
}
