package lc.conflux;

import java.io.IOException;

/**
 * Classes implementing this interface store named {@link DataSource} objects.
 *
 * @author Alex Leigh
 */
public interface DataSourceBinder {
    /**
     * Return the {@link DataSource} of the given name to the caller, or <code>null</code> if no such
     * DataSource is registered. <code>name</code> must not be null.
     *
     * @param name The {@link DataSource}.
     */
    DataSource getDataSource(String name) throws IOException, ClassNotFoundException;
}
