#ifndef _ATG_SYSTEM_H_
#define _ATG_SYSTEM_H_
/* system.h:
 *
 * system-specific includes and definitions.
 *
 * Copyright (C) 1997 Art Technology Group, Inc.
 * All Rights Reserved.  No use, copying or distribution of this
 * work may be made except in accordance with a valid license
 * agreement from Art Technology Group.  This notice must be
 * included on all copies, modifications and derivatives of this
 * work.
 */
#ifdef WIN32
#include <windows.h>
#include <winsock.h>
#include <stdio.h>

#else /* assume it is UNIX */

#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#if defined(SOLARIS) || defined(SOLARIS2)
/* we need to pick up FIONBIO from ioctl.h, which is only defined in BSD
 * compatibility mode in Solaris.
 */
#define BSD_COMP
#endif /* SOLARIS */

#if defined(AIX) || defined(_AIX) || defined(LINUX) || defined(_HPUX) || defined(OPENBSD)
#include <sys/poll.h>
#endif /* AIX */

#include <sys/ioctl.h>

#define stricmp strcasecmp
#define strnicmp strncasecmp

#ifndef LINUX
char* strdup(const char*);
#endif

#endif /* WIN32 */

#endif /* !_ATG_SYSTEM_H_ */
