/*
 * Copyright (c) 2004-2017, by Alex Leigh.
 * All rights reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 */

package lc.eo.schema.dao;

import lc.eo.EO;
import lc.eo.EOLoop;

/**
 * This is a dynamically generated DAO class for accessing objects within an ESP graph. This class
 * has been generated by <code>DAOGenerator</code> and should not be modified.
 *
 * @author DAOGenerator (synthetically generated class)
 */
public final class LoopElementDAO {
    public static final String API_TYPE = "org.a6v.esp.eo.schema.Loop";

    public static EO create() {
        EO eo = new EO(API_TYPE);
        return eo;
    }

    public static boolean assertType(final EO eo) {
        return eo.getApiType().equals(API_TYPE);
    }

    public static final String KEY_APINAME = "apiName";
    public static final String KEY_LABEL = "label";
    public static final String KEY_ACCEPTTYPES = "acceptTypes";

    public static String apiType(final EO eo) {
        return eo.getApiType();
    }


    /* EO{typeName='org.a6v.esp.eo.schema.Field', data={apiName=apiName, label=EOLoop{array=[EO{typeName='org.a6v.esp.eo.schema.Text', data={text=API Name, locale=en}, errors={}, globalErrors=[]} org.a6v.esp.eo.EO@134dd9f0]} org.a6v.esp.eo.EOLoop@134dda0f, type=string}, errors={}, globalErrors=[]} org.a6v.esp.eo.EO@33b498 */


    public static java.lang.String getApiName(EO eo) {
        if (!assertType(eo)) throw new IllegalArgumentException("Mismatched EO type: " + eo.getApiType());
        return eo.getValueString(KEY_APINAME);

    }

    public static void setApiName(final EO eo, java.lang.String value) {
        if (!assertType(eo)) throw new IllegalArgumentException("Mismatched EO type: " + eo.getApiType());
        eo.setValue(KEY_APINAME, value);
    }


    /* EO{typeName='org.a6v.esp.eo.schema.Loop', data={acceptTypes=EOLoop{array=[EO{typeName='org.a6v.esp.eo.schema.AcceptType', data={elementApiName=org.a6v.esp.eo.schema.Text}, errors={}, globalErrors=[]} org.a6v.esp.eo.EO@d962a4a2]} org.a6v.esp.eo.EOLoop@d962a4c1, apiName=label, label=Label}, errors={}, globalErrors=[]} org.a6v.esp.eo.EO@c6fa5811 */

    public static void appendLabel(EO eo, EO label) {
        EOLoop loop = eo.getValueLoop(KEY_LABEL);
        loop.add(label);
    }

    public static EOLoop getLabel(EO eo) {
        EOLoop o = eo.getValueLoop(KEY_LABEL);
        if (o == null) {
            o = new EOLoop();
            eo.setValue(KEY_LABEL, o);
        }
        return o;

    }

    public static void setLabel(final EO eo, EOLoop value) {
        if (!assertType(eo)) throw new IllegalArgumentException("Mismatched EO type: " + eo.getApiType());
        eo.setValue(KEY_LABEL, value);
    }


    /* EO{typeName='org.a6v.esp.eo.schema.Loop', data={acceptTypes=EOLoop{array=[EO{typeName='org.a6v.esp.eo.schema.AcceptType', data={elementApiName=org.a6v.esp.eo.schema.AcceptType}, errors={}, globalErrors=[]} org.a6v.esp.eo.EO@11fa82d9]} org.a6v.esp.eo.EOLoop@11fa82f8, apiName=acceptTypes, label=Accept Types}, errors={}, globalErrors=[]} org.a6v.esp.eo.EO@3ac0c602 */

    public static void appendAcceptTypes(EO eo, EO label) {
        EOLoop loop = eo.getValueLoop(KEY_ACCEPTTYPES);
        loop.add(label);
    }

    public static EOLoop getAcceptTypes(EO eo) {
        EOLoop o = eo.getValueLoop(KEY_ACCEPTTYPES);
        if (o == null) {
            o = new EOLoop();
            eo.setValue(KEY_ACCEPTTYPES, o);
        }
        return o;

    }

    public static void setAcceptTypes(final EO eo, EOLoop value) {
        if (!assertType(eo)) throw new IllegalArgumentException("Mismatched EO type: " + eo.getApiType());
        eo.setValue(KEY_ACCEPTTYPES, value);
    }


}