package lc.esp.engine.service;

import lc.mecha.log.MechaLogger;
import lc.mecha.log.MechaLoggerFactory;
import lc.mecha.util.BasicallyDangerous;
import lc.mecha.util.UniversalJob;
import org.apache.activemq.broker.BrokerPlugin;
import org.apache.activemq.broker.BrokerService;
import org.apache.activemq.usage.SystemUsage;

import static java.lang.Thread.sleep;

public class EngineService extends BasicallyDangerous {
    private static final MechaLogger logger = MechaLoggerFactory.getLogger(EngineService.class);

    public static void main(String args[]) throws InterruptedException {
        UniversalJob.banner(logger, "Enhanced Services Platform mk18/ENGINE (GIPSY DANGER)");

        EngineService eng = new EngineService();
        eng.run();

        while (true) {
            sleep(1000);
        }
    }
    @Override
    public void runDangerously() throws Exception {
        BrokerService broker = new BrokerService();
        broker.addConnector("tcp://0.0.0.0:52018");
        broker.addConnector("mqtt://0.0.0.0:52019");
        broker.addConnector("stomp://0.0.0.0:52020");
        broker.addConnector("ws://0.0.0.0:52021");
        broker.setPersistent(false);
        broker.setPlugins(new BrokerPlugin[]{new EnhancedBrokerPlugin()});
        new EnhancedBrokerPlugin().installPlugin(broker.getBroker());
        broker.start();

        //noinspection InfiniteLoopStatement
        while (true) {
            SystemUsage su = broker.getConsumerSystemUsage();
            logger.info("{}", su.getMemoryUsage());
            logger.info("{}", su.getStoreUsage());
            logger.info("{}", su.getTempUsage());
            sleep(60 * 1000);
        }
    }
}
