package lc.esp.monitor.app;

import lc.esp.sdk.*;
import lc.mecha.log.MechaLogger;
import lc.mecha.log.MechaLoggerFactory;
import lc.mecha.util.UniversalJob;
import org.apache.commons.lang.StringUtils;

public class MonitorApp {
    private static final MechaLogger logger = MechaLoggerFactory.getLogger(MonitorApp.class);
    public static final String ENV_ADDRESS = "LC_ADDRESS";

    public static void main(String[] args) throws Exception {
        String address = System.getenv(ENV_ADDRESS);
        if (StringUtils.isEmpty(address)) {
            logger.info(ENV_ADDRESS + " environment variable must be set.");
            System.exit(UniversalJob.RET_BADARGS);
        }

        ESPClient esp = new ESPClient();
        esp.start();

        ESPAddress telemDest = new ESPAddress(address);

        logger.info("Reading from address: {}", telemDest);

        ESPSession session = esp.createSession();
        ESPConsumer consumer = session.createConsumer(telemDest);

        //noinspection InfiniteLoopStatement
        while (true) {
            ESPMessage msg = consumer.receive();
            System.out.println(msg.toJson());
        }
    }
}
