package lc.esp.sdk;

import java.util.Locale;

/**
 * This enum defines the semantics for an {@link ESPAddress}. The two options available are topic or queue whose
 * nomenclature lines up with JMS and other popular Message Queue implementations.
 *
 * @author Alex Leigh
 * @since mk18 (GIPSY DANGER)
 */
public enum ESPAddressClass {
    TOPIC, QUEUE;

    public static ESPAddressClass val(String str) {
        switch (str.toLowerCase(Locale.ROOT)) {
            case "topic":
                return TOPIC;
            case "queue":
                return QUEUE;
        }
        throw new IllegalStateException("Unknown class: " + str);
    }
}
