package lc.esp.sdk;

import java.util.Locale;

/**
 * This enum contains valid destination classes. It is capable of converting the symantic meaning to the correct
 * abbreviation for ESP18 addresses.
 *
 * @author Alex Leigh
 * @since mk18 (GIPSY DANGER)
 */
public enum ESPMessageClass {
    TELEMETRY {
        public String toString() {
            return "tlm";
        }
    },
    COMMAND {
        public String toString() {
            return "cmd";
        }
    };

    public static ESPMessageClass val(String str) {
        switch (str.toLowerCase(Locale.ROOT)) {
            case "tlm":
                return TELEMETRY;
            case "cmd":
                return COMMAND;
        }
        throw new IllegalStateException("Unknown symbol: " + str);
    }
}