package lc.esp.sdk;

import javax.jms.Connection;
import javax.jms.JMSException;
import javax.jms.Session;

public class ESPSession implements AutoCloseable {
    private final Session session;

    public ESPSession(Connection connection) throws JMSException {
        this.session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
    }

    public ESPConsumer createConsumer(ESPAddress destination) throws JMSException {
        return new ESPConsumer(destination, session);
    }

    public ESPProducer createProducer(ESPAddress destination) throws JMSException {
        return new ESPProducer(session, destination);
    }

    @Override
    public void close() throws Exception {
        session.close();
    }
}
