package lc.evelyn.svc;

import lc.mecha.log.MechaLogger;
import lc.mecha.log.MechaLoggerFactory;
import org.pircbotx.Configuration;
import org.pircbotx.PircBotX;
import org.pircbotx.hooks.ListenerAdapter;
import org.pircbotx.hooks.types.GenericMessageEvent;

public class EvelynService extends ListenerAdapter {
    private static final MechaLogger logger = MechaLoggerFactory.getLogger(EvelynService.class);

    public static void main(String[] args) throws Exception {
        Configuration configuration = new Configuration.Builder()
                .setName("Evelyn")
                .addServer("irc0.leigh-co.com")
                .addAutoJoinChannel("#leighco")
                .addListener(new EvelynService())
                .setRealName("Evelyn")
                .setWebIrcUsername("evelyn")
                .buildConfiguration();

        PircBotX bot = new PircBotX(configuration);
        new Thread(new PastebinThread(bot)).start();


        bot.startBot();
    }

    @Override
    public void onGenericMessage(GenericMessageEvent event) {
        if (event.getMessage().startsWith("eve: hello"))
            event.respond("Hello!");
    }
}
