# Copyright:: 2012-2019, Chef Software, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include_recipe 'postfix::_common'

postmap_command = platform_family?('rhel') ? '/usr/sbin/postmap' : 'postmap'

execute 'update-postfix-relay-restrictions' do
  command "#{postmap_command} #{node['postfix']['relay_restrictions_db']}"
  environment PATH: "#{ENV['PATH']}:/opt/omni/bin:/opt/omni/sbin" if platform_family?('omnios')
  action :nothing
end

template node['postfix']['relay_restrictions_db'] do
  source 'relay_restrictions.erb'
  notifies :run, 'execute[update-postfix-relay-restrictions]', :immediately
end
