package lc.mecha.nodegraph;

import java.util.List;

/**
 * This class represents a node graph. Currently the graph is stored internally as a list of
 * {@link NodeObject}s, which describe each of the nodes on the graph and together comprise the
 * entire graph.
 * <p>
 * The NodeGraph stores connections "backwards", so for the purposes of a connection, the src is the receiving
 * node and the dst is the sending node. This allows the graph to easily be transversed from child through
 * its parental lineage, which is its typical use-case for Conflux.
 *
 * @author Alex Leigh
 */
public class NodeGraph {
    private final List<NodeObject> nodes;

    public NodeGraph(List<NodeObject> nodes) {
        this.nodes = nodes;
    }

    public List<NodeObject> getNodes() {
        return nodes;
    }
}
