/*
 * Copyright (c) 2004-2017, by Alex Leigh.
 * All rights reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 */

package lc;

import lc.mecha.log.MechaLogger;
import lc.mecha.log.MechaLoggerFactory;
import lc.mecha.util.UniversalJob;

/**
 * Utility class which centralizes the ESP version information.
 *
 * @author Alex Leigh
 */
public final class BuildVersion {
    private static final MechaLogger logger = MechaLoggerFactory.getLogger(BuildVersion.class);
    public static String MASSIVE_VERSION = "mk16 mod0 (ADVANCE)";
    public static String ESP_PROD_STR = "Enhanced Services Platform " + MASSIVE_VERSION + " / KABE";

    /**
     * Simple command line program which prints the banner text and then exits. This is useful
     * for determining the version of ESP contained within the build.
     */
    public static void main(final String[] args) {
        UniversalJob.banner(logger, ESP_PROD_STR);
    }
}
