/*
 * LEIGH:plc
 * Copyright 2022 Alex Leigh
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DMX_H
#define _DMX_H

#include <stdint.h>
#include <stdio.h>

enum DMXDirection { input, output };
enum DMXState { DMX_IDLE, DMX_BREAK, DMX_DATA, DMX_OUTPUT };

uint8_t dmxFread(uint16_t channel);
void dmxFread_all(uint8_t *data, uint16_t start, size_t size);
void dmxFwrite(uint16_t channel, uint8_t value);
void dmxFwrite_all(uint8_t *data, uint16_t start, size_t size);
uint8_t dmxFis_healthy();
void dmxFuart_event_task(void *pvParameters);

#endif