package lc.zero.sdk;

import lc.mecha.json.JSONObject;

/**
 * THis class holds the configuration for a ZERO service. The configuration is application-specific and therefore
 * not specified here. It is presented as a {@link JSONObject}.
 *
 * @author Alex Leigh
 * @since mk1 (PUMA REAL)
 */
public class ZeroServiceConfig {
    private final String name;
    private final JSONObject cfg;

    public ZeroServiceConfig(String name, JSONObject cfg) {
        this.name = name;
        this.cfg = cfg;
    }

    public String getName() {
        return name;
    }

    public JSONObject getCfg() {
        return cfg;
    }

    @Override
    public String toString() {
        return "ServiceConfig{" +
                "name='" + name + '\'' +
                ", cfg=" + cfg +
                '}';
    }
}
